  DECLARE SUB ReadChars ()
  DECLARE SUB ShowChars (Text$)
  DECLARE SUB StoreChars (StartRange%, EndRange%)
  DECLARE SUB WriteChars (StartRange%, EndRange%)

  REM $DYNAMIC

  CLEAR

  RANDOMIZE TIMER

  StartRange% = 33
  EndRange% = 255

  DIM SHARED Chars(StartRange% TO EndRange%, 8, 16) AS STRING * 1

  DIM SHARED CharsPos$(StartRange% TO EndRange%)


  'LINE (0, 0)-(640, 480), 7, BF

  'remove the following two remarks to create a font-file with your char-range
  StoreChars StartRange%, EndRange%
  END

  ReadChars

  SCREEN 12

  LOCATE 1, 1
'  ShowChars "abcdefghijklmnopqrstuvwxyz"
'  END
  ShowChars "Testing..."

  PRINT

  SLEEP (2)

  ShowChars "I was wondering if there could be more on heaven and earth."

  SLEEP (2)

  ShowChars "Strange..."

  SLEEP (1)

  ShowChars ".."

  SLEEP

  SCREEN 0

REM $STATIC
SUB ReadChars

  OPEN "default.fnt" FOR BINARY AS #1

  Range% = 0

  GET #1, LOC(1) + 1, Range%

  Fonts$ = STRING$(LOF(1) - 2, CHR$(0))

  GET #1, LOC(1) + 1, Fonts$

  CLOSE

  Optiva% = 33

  Terminate$ = CHR$(0) + CHR$(0)

  DO
   
    IF INSTR(Fonts$, Terminate$) > 0 THEN
    
      CharsPos$(Optiva%) = LEFT$(Fonts$, INSTR(Fonts$, Terminate$) - 1)
    
      Fonts$ = RIGHT$(Fonts$, LEN(Fonts$) - LEN(CharsPos$(Optiva%)) - 2)
    
      Optiva% = Optiva% + 1
    ELSE
      EXIT DO
    END IF
 
  LOOP

  CLOSE

END SUB

SUB ShowChars (Text$)


  DroppleX% = POS(X) * 8
  DroppleY% = CSRLIN * 16

  BckGrColor% = 3
  FrGrColor% = 11

  FOR a% = 1 TO LEN(Text$)
     
    LINE (1 + DroppleX%, 1 + DroppleY%)-(8 + DroppleX%, DroppleY% + 16), BckGrColor%, BF
  
    Letter% = ASC(MID$(Text$, a%, 1))
  
    IF Letter% <> 32 THEN
    
      FOR T% = 1 TO LEN(CharsPos$(Letter%)) STEP 2
        X% = ASC(MID$(CharsPos$(Letter%), T%, 1))
      
        Y% = ASC(MID$(CharsPos$(Letter%), T% + 1, 1))
      
        PSET (X% + DroppleX%, Y% + DroppleY%), FrGrColor%
      NEXT T%
  
    END IF

    IF MID$(Text$, a%, 1) <> " " THEN
      PlayIt$ = "t255 L64 P64 MN N" + LTRIM$(STR$(FIX((42))))
    
      PLAY PlayIt$
    END IF

    DroppleX% = DroppleX% + 8
 
    SELECT CASE DroppleX%
  
      CASE IS >= 640
        DroppleX% = 0
        DroppleY% = DroppleY% + 16
    
        IF DroppleY% > 480 THEN
          DroppleY% = DroppleY% - 16
        END IF

    END SELECT

  NEXT a%

  PRINT

END SUB

SUB StoreChars (StartRange%, EndRange%)

  SCREEN 12

  FOR a% = StartRange% TO EndRange%
    LOCATE 1, 1

    COLOR 1

    PRINT CHR$(a%)

    FOR Xscan% = 0 TO 7
   
      FOR YScan% = 0 TO 15
     
        Kleur% = POINT(Xscan%, YScan%)
     
        SELECT CASE Kleur%
        
          CASE IS <> 0
            LOCATE YScan% + 2, Xscan% + 1
     
            Chars(a%, Xscan% + 1, YScan% + 1) = "*"
        
          CASE IS = 0
            LOCATE YScan% + 2, Xscan% + 1
         
            Chars(a%, Xscan% + 1, YScan% + 1) = " "
    
        END SELECT
    
      NEXT YScan%
  
    NEXT Xscan%

  NEXT a%

  WriteChars StartRange%, EndRange%

END SUB

SUB WriteChars (StartRange%, EndRange%)

  OPEN "default.fnt" FOR BINARY AS #1

  Range% = EndRange% - StartRange%

  PUT #1, LOC(1) + 1, Range%

  FOR a% = StartRange% TO EndRange%

    FOR Y% = 1 TO 16
    
      FOR X% = 1 TO 8
       
        IF Chars(a%, X%, Y%) = "*" THEN
          Set$ = CHR$(X%) + CHR$(Y%)
        
          PUT #1, LOC(1) + 1, Set$
        END IF
       
      NEXT X%
   
    NEXT Y%
  
    Set$ = CHR$(0) + CHR$(0)
  
    PUT #1, LOC(1) + 1, Set$
  NEXT a%

  CLOSE

END SUB

