'
' SidBase Database maintainer, DosGui version 2.51 by Vincent Voois
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'
' Long Filenames under Win'95 V0.4 (Mark Kim)
'
' Database builder 0.3 (Lfn-support) (Vv)
'
' User configuration V0.7 (Vv)
'
' Mouse support available, several button bugs to fix yet: V0.1 (Vv)
'
' XMS memory support: V0.3 (Robin Duffy)
'
' None-recursive QuickSort routine: V0.1 (Mike Huth)
'
' Database engine: V0.2 (Vv)
'
' Search engine: not implemented yet. (Vv)
'
' User Control on Databasefunctions: v0.4 (Vv)
'
' Install sidfiles from pkzip (long and short): not implemented yet. (Vv)
'
' user addable/configurable database files: not implemented yet. (Vv)
'

	DEFINT A-Z

	REM $DYNAMIC

	REM $INCLUDE: 'SidDeclr.inc'
	REM $INCLUDE: 'IsWin.inc'
	REM $INCLUDE: 'Sidbase.bi'
	REM $INCLUDE: 'XmsVals.inc'
	REM $INCLUDE: 'LFN.INC'
 
	CONST WindowX% = 9
 
	CLOSE
 
	ChoiceColor% = 3
 
	HighLightColor% = 11

	TextColorBox% = 10
 
	TextColor% = 4

	BackGroundColor% = 7

	Module$ = UCASE$("SidBase.bas")

	SeekWindows
 
	CheckXMs

	GetRootFileInfo
 
	IF INSTR(COMMAND$, "?") > 0 THEN
		ShowCommandLineHelp
	END IF
 
	ReadChars
 
	SetScreen

	FillCenter
 
	COLOR TextColor%

	AttentOSMode

	TestMouse

	CheckIniFile
 
	TestMainDatabase
 
	ControlCentre

	'St$ = "Exitting..."
	 
	'PLACE 2, CRSLIN + 2, "Box", St$, TextColor%
 
	SCREEN 0

	'RetrieveSongDatas

	Terminate

Fout:
	Fout% = ERR
 
	Error$ = "ERROR " + LTRIM$(RTRIM$(STR$(Fout%))) + ":"
 
	Error$ = Error$ + " Stupidity from the programmer."
 
	IF Catch% <> 1 THEN
		SCREEN 0
	 
		LOCATE 1, 1
	 
		PRINT Error$
		PRINT "Error found in module:["; Module$; "]"
		PRINT "Subroutine:["; SubSource$; "]"
		PRINT
		PRINT "Please notify error module and subroutine to:Vv@musician.org"
	 
		Terminate
	 
		'SLEEP
 
	ELSE
		Catch% = 0
	END IF

	RESUME NEXT

REM $STATIC
SUB ArrangeSidData
		LOCATE CSRLIN + 1, 2

		St$ = "Database Corruption detected rearranging Sid-database..."

		PLACE 2, CSRLIN + 1, "box", St$, TextColor%

		PRINT
	 
		FOR PsidFile& = 1 TO FileLines&
	
		Catch% = 1
	 
		TempHandler% = 1
	 
		C64MusicFile$ = GetReeks$(PsidFile&)

		getsonginfo
 
		IF UCASE$(PsidInfo$) = "PSID" THEN
			TempHandler% = 2
	 
			LinePos& = LinePos& + 1

			Liner$ = SongName$ + SongAuthor$ + SongCopyright$ + STR$(LinePos&)
			
			PutReeks Liner$, PsidFile&
			
			Valid& = Valid& + 1
		ELSE
			Invalid$ = STRING$(Leng%, " ")
		 
			PutReeks Invalid$, PsidFile&
		END IF
	 
		Percent% = CLNG(PsidFile& / FileLines& * 100)
	 
		Progress Percent%, 4
	
		CheckInkey

		Cancel

		Quit
	NEXT PsidFile&

	Pbar% = 0

	Invalid$ = ""

	C64MusicFile$ = ""

	TempFile% = FREEFILE

	OPEN OwnPath$ + "MAINARCH.SFN" FOR OUTPUT AS #TempFile%

	TempData% = FREEFILE

	OPEN OwnPath$ + ExeFile$ + ".IDB" FOR BINARY AS #TempData%

	LengX% = 0

	LOCATE CSRLIN + 1, 2

	St$ = "Saving the stuff..."

	PLACE 2, CSRLIN + 1, "box", St$, TextColor%

	PRINT
 
	FOR PsidFile& = 1 TO FileLines&
		Catch% = 1
	
		TempHandler% = 1
	 
		ValidFile$ = GetReeks$(PsidFile&)
	
		IF ValidFile$ <> "" THEN
	
			IF LEN(ValidFile$) > LengX% THEN
				LengX% = LEN(ValidFile$)
			END IF

			TempHandler% = 2

			ValidData$ = GetReeks$(PsidFile&)
		
			ValidNumber$ = MID$(ValidData$, 97)
		
			ValidData$ = LEFT$(ValidData$, 96)
		
			VNumber& = VAL(ValidNumber$)

			PRINT #TempFile%, ValidFile$
		
			PUT #TempData%, LOC(TempData%) + 1, ValidData$
		
			PUT #TempData%, LOC(TempData%) + 1, VNumber&
	
			ValidSidFile& = ValidSidFile& + 1
		END IF

		HadLen& = PsidFile& + 2
 
		Percent% = CLNG(HadLen& / FileLines& * 100)

		Progress Percent%, 4
 
		CheckInkey

		Cancel

		Quit
	NEXT PsidFile&

	Pbar% = 0

	FileLines& = ValidSidFile&

	Leng% = LengX%

END SUB

SUB AttentOSMode
 
	SubSource$ = "AttentOSMode"
 
	SELECT CASE OsMode%
	 
		CASE IS = 1
			St$ = "Dos mode enabled."
 
		CASE IS = 2
			St$ = "Using dos mode underneath Windows 386 2.x"
	 
		CASE IS = 3
			St$ = "Using dos mode underneath Windows 3.x"
	 
		CASE IS = 4
			St$ = "Windows '95 or simular detected, Long filename support enabled."
	 
		CASE ELSE
			St$ = "You are running a different or incompatible OS unlike Windows OR dos:" + STR$(OsMode%)
			
			PLACE 2, 3, "BOX", St$, TextColor%
		 
			PRINT
		 
			DO
				H$ = INKEY$
			LOOP UNTIL H$ <> ""
		 
			H$ = ""

			SCREEN 0

			Terminate

	END SELECT
	 
	PLACE 2, 3, "BOX", St$, TextColor%

	PRINT
END SUB

DEFSNG A-Z
SUB BorderLinesBox (StartX%, StartY%, Letters!, Rules%)
	SubSource$ = UCASE$("BorderLinesBox")
 
	COLOR TextColorBox%
 
	Height% = (Rules% * 16) + 2
 
	Length% = (Letters! * 8) + 2

	LINE (StartX%, StartY%)-(StartX% + Length%, StartY%), 8
	LINE (StartX%, StartY%)-(StartX%, StartY% + Height%), 8
	LINE (StartX% + 1, StartY% + 1)-(StartX% + Length% - 1, StartY% + 1), 8
	LINE (StartX% + 1, StartY% + 1)-(StartX% + 1, StartY% + Height% - 1), 8
	LINE (StartX% + 1, StartY% + Height%)-(StartX% + Length%, StartY% + Height%), 15
	LINE (StartX% + Length%, StartY% + 1)-(StartX% + Length%, StartY% + Height%), 15
 
END SUB

SUB BorderLinesButton (StartX%, StartY%, Letters!, Rules%)
	SubSource$ = UCASE$("BorderLinesButton")
 
	Height% = (Rules% * 16) + 2
 
	Length% = (Letters! * 8) + 2

	LINE (StartX%, StartY%)-(StartX% + Length%, StartY%), 15
	LINE (StartX%, StartY%)-(StartX%, StartY% + Height%), 15
	LINE (StartX% + 1, StartY% + 1)-(StartX% + Length% - 1, StartY% + 1), 15
	LINE (StartX% + 1, StartY% + 1)-(StartX% + 1, StartY% + Height% - 1), 15
	LINE (StartX% + 1, StartY% + Height%)-(StartX% + Length%, StartY% + Height%), 8
	LINE (StartX% + Length%, StartY% + 1)-(StartX% + Length%, StartY% + Height%), 8

END SUB

DEFINT A-Z
SUB BuildControlScreen
 
	FillViewPort

	LOCATE 2, WindowX% - 1

	MarkArea WindowX% - 1, CSRLIN, 15, 64, "Box", 1

	St$ = "Status:Groovy..."

	StatusLine "box", St$, TextColor%

	St$ = "[F1]: Help."

	PLACE 2, 23, "nothing", St$, 0
 
	St$ = "[S]earch:"

	PLACE 2, 27, "nothing", St$, TextColor%

	St$ = "[G]o to:"

	PLACE 2, 25, "nothing", St$, TextColor%

	St$ = "Pos:"

	PLACE WindowX%, 19, "box", St$, TextColor%
 
	St$ = "Total:"

	PLACE WindowX% + 13, 19, "box", St$, TextColor%
 
	St$ = RTRIM$(LTRIM$(STR$(FileLines&)))
	 
	IF LEN(St$) < 6 THEN
		St$ = STRING$(6 - LEN(St$), "0") + St$
	END IF

	PLACE WindowX% + 7 + 13, 19, "box", St$, TextColor%
 
END SUB

DEFSNG A-Z
SUB Cancel STATIC
	SubSource$ = UCASE$("Cancel")
 
		St$ = "Cancel Building"
	 
		IF CancelButton% = 0 THEN
			PLACE 65, 28, "BUTTON", St$, TextColor%
		
			CancelButton% = 1
		END IF

		ZetPointerAan
	 
		LeesMuisIo Button%, Mx%, My%
	 
		IF Button% = 1 OR Toets% = 301 AND Locked% = 0 THEN
				 
			IF (Mx% >= 512 AND Mx% <= 630) AND (My% >= 432 AND My% <= 447) AND CStarter% = 0 OR Toets% = 301 AND Locked% = 0 THEN
				Toets$ = ""
			 
				ZetPointerUit
			 
				PLACE 65, 28, "switchbox", St$, TextColor%
			 
				ZetPointerAan
	
				CStarter% = 1
			 
				Locked% = 1
			END IF
	
		ELSE
	
			IF CStarter% = 1 AND Toets% = 0 THEN
				CStarter% = 0

				IF Locked% = 1 THEN
					ZetPointerUit
			 
					PLACE 65, 28, "BUTTON", St$, TextColor%
			 
					ZetPointerAan
				 
					Locked% = 0
				END IF

			END IF
	
		END IF

END SUB

SUB CheckIniFile STATIC
	SubSource$ = UCASE$("CheckIniFile")
 
	ON ERROR GOTO Fout

	OPEN OwnPath$ + ExeFile$ + ".INI" FOR BINARY AS #1

	Catch% = 1
 
	IF LOF(1) = 0 THEN
		CLOSE #1
	
		KILL OwnPath$ + ExeFile$ + ".INI"
	
		OPEN OwnPath$ + ExeFile$ + ".INI" FOR OUTPUT AS #1
	
		ZetPointerUit
	 
		St$ = "Database configfile has not been found, please enter the proper path to your"
	 
		PLACE 3, CSRLIN + 1, "nothing", St$, TextColor%
	 
		St$ = "c64music directory like: C:\C64MUSIC below this line:                       "
	 
		PLACE 3, CSRLIN, "nothing", St$, TextColor%
	 
		Spot% = CSRLIN + 1

		DO
			LOCATE Spot%, 2
	 
			Startm% = ((CSRLIN - 1) * 16) - 2
	 
			BorderLinesBox 6, Startm%, 78, 1
	 
			Yer% = CSRLIN
 
			Xer% = 2
	 
			ZetPointerAan
	 
			StuurToets Xer%, Yer%, "nothing", EntryString$, 77

			IF EntryString$ = CHR$(27) THEN
				Terminate
			END IF

			C64MusicPath$ = EntryString$
		 
			IF C64MusicPath$ = "" THEN
				St$ = "Please enter a given path or hit the " + CHR$(34) + "Esc" + CHR$(34) + "-key to exit"
				
				StatusLine "box", St$, TextColor%
			END IF

		LOOP UNTIL C64MusicPath$ <> ""

		PRINT #1, C64MusicPath$
	 
		LOCATE CSRLIN, 2
	 
		Startm% = ((CSRLIN - 1) * 16) - 2
	 
		ZetPointerUit
	 
		St$ = "If you want SidPlay to be callable from this database fill in the path to sid-"
	 
		PLACE 2, CSRLIN + 1, "nothing", St$, TextColor%
	 
		St$ = "play (windows or dos)                                                         "
	 
		PLACE 2, CSRLIN, "nothing", St$, TextColor%
	 
		St$ = "Leave the line blank if you don't have or want to use sidplay from here.      "
	 
		PLACE 2, CSRLIN, "nothing", St$, TextColor%
	 
		LOCATE CSRLIN + 1, 2
	
		Startm% = ((CSRLIN - 1) * 16) - 2
	
		BorderLinesBox 6, Startm%, 78, 1
	
		Yer% = CSRLIN
	 
		Xer% = 2
	 
		ZetPointerAan
		 
		StuurToets Xer%, Yer%, "nothing", EntryString$, 77

		IF EntryString$ = "" OR EntryString$ = CHR$(27) THEN
			SidPlayPath$ = "Disabled"
		ELSE
			SidPlayPath$ = EntryString$
		END IF
	
		TestFile% = FREEFILE
	 
		Catch% = 1

		OPEN SidPlayPath$ FOR BINARY AS #TestFile%

		SELECT CASE Fout%
				 
			CASE IS = 0
			 
				IF LOF(TestFile%) = 0 THEN
					CLOSE TestFile%
			 
					KILL SidPlayPath$
			 
					SidPlayPath$ = "Disabled"
			 
					St$ = "SidPlay executable not located. feature disabled"
			
					StatusLine "box", St$, 11
				END IF
		
			CASE ELSE
				SidPlayPath$ = "Disabled"
			
				St$ = "SidPlay executable not located. feature disabled"
			 
				StatusLine "box", St$, 11
	 
		END SELECT
	 
		PRINT #1, SidPlayPath$
	
		LOCATE CSRLIN + 1, 3
	 
		IF SidPlayPath$ <> "Disabled" THEN
		 
			ZetPointerUit
		 
			St$ = "Enter your desired commandparameters wich should be given to sidplay besides"
			PLACE 3, CSRLIN, "nothing", St$, TextColor%
		
			St$ = "the songname. (soundcardsettings, playlists etc..)                          "
			PLACE 3, CSRLIN, "nothing", St$, TextColor%
		 
			LOCATE CSRLIN + 1, 2
 
			Startm% = ((CSRLIN - 1) * 16) - 2
 
			BorderLinesBox 6, Startm%, 78, 1
 
			Yer% = CSRLIN
	
			Xer% = 2
		 
			ZetPointerAan
		
			StuurToets Xer%, Yer%, "nothing", EntryString$, 77

			IF EntryString$ = "" OR EntryString$ = CHR$(27) THEN
				PRINT #1, "Disabled"
			 
				SidPlayCommand$ = "Disabled"
			ELSE
				PRINT #1, EntryString$
			END IF
		
		ELSE
			PRINT #1, "Disabled"
		 
			SidPlayCommand$ = "Disabled"
		END IF
	 
		PRINT #1, "0.7"
		PRINT #1, "Don't edit this file, everything depends on the small number above this line."
		PRINT #1, "And the program depends on the information stated inside this file."
	
		CLOSE
	 
		FillViewPort
	 
		ZetPointerUit
	 
		Xer% = (80 - LEN("Thank you, you've been very cooperative today.")) \ 2
	 
		LOCATE 8, Xer%
	 
		Startm% = ((CSRLIN - 1) * 16) - 2
	 
		BorderLinesBox 126, Startm%, LEN("Thank you, you've been very cooperative today."), 5

		St$ = "Thank you, you've been very cooperative today."
	 
		PLACE Xer%, 8, "nothing", St$, TextColor%
	 
		St$ = "      I hope you enjoy the automated          "
	 
		PLACE Xer%, CSRLIN, "nothing", St$, TextColor%
	 
		St$ = "database collector and have some effort to it."
	 
		PLACE Xer%, CSRLIN, "nothing", St$, TextColor%
	 
		St$ = STRING$(LEN("Thank you, you've been very cooperative today."), " ")
	 
		PLACE Xer%, CSRLIN, "nothing", St$, TextColor%
	 
		St$ = "               Vincent Voois                  "
	 
		PLACE Xer%, CSRLIN, "nothing", St$, TextColor%
	 
		ZetPointerAan
	 
		ShowOkButton 28, 14
	 
		FillViewPort

		SHELL "copy " + OwnPath$ + ExeFile$ + ".INI " + OwnPath$ + ExeFile$ + ".BCK>nul"
	ELSE
		CLOSE
	
		OPEN OwnPath$ + ExeFile$ + ".INI" FOR INPUT AS #1
	
		LINE INPUT #1, C64MusicPath$
	 
		IF Fout% = 62 THEN
			Fout% = 0
		 
			ClearIni
		END IF

		IF LEFT$(C64MusicPath$, 1) <> "\" AND MID$(C64MusicPath$, 2, 1) <> ":" THEN
			ClearIni
		END IF
	
		LINE INPUT #1, SidPlayPath$
	
		IF Fout% = 62 THEN
			Fout% = 0
		
			ClearIni
		END IF

		LINE INPUT #1, SidPlayCommand$
	 
		IF Fout% = 62 THEN
			Fout% = 0
		
			ClearIni
		END IF

		LINE INPUT #1, VerNummer$
	 
		IF Fout% = 62 THEN
			Fout% = 0
		
			ClearIni
		END IF

		VerNummer% = VAL(VerNummer$)

		LOCATE CSRLIN + 1, 2
	 
		MarkSpot% = CSRLIN - 1
	 
		PRINT "Configuration-data loaded..."
	 
		BorderLinesBox 6, (MarkSpot% * 16) - 2, 28, 1

		ShowOkButton ((80 - 22) \ 2), 15
		
		CLOSE
	 
		IF VerNummer% = 0 OR VerNummer% > 1 THEN
			KILL OwnPath$ + ExeFile$ + ".INI"
		 
			OPEN OwnPath$ + ExeFile$ + ".INI" FOR OUTPUT AS #1
		 
			PRINT #1, C64MusicPath$
			PRINT #1, SidPlayPath$
			PRINT #1, SidPlayCommand$
			PRINT #1, "0.7"
			PRINT #1, "Don't edit this file, everything depends on the small number above this line."
			PRINT #1, "And the program depends on the information stated inside this file."
 
			CLOSE
		END IF

		FillViewPort

	END IF
 
	IF RIGHT$(C64MusicPath$, 1) = "\" THEN
		C64MusicPath$ = LEFT$(C64MusicPath$, LEN(C64MusicPath$) - 1)
	END IF
 
	LOCATE 3, 2

	QuitButton% = 0

END SUB

SUB CheckInkey
	SubSource$ = UCASE$("CheckInKey")
	 
		Toets$ = INKEY$
		 
		SELECT CASE LEN(Toets$)
		 
			CASE IS = 1
				Toets$ = LCASE$(Toets$)
			 
				Toets% = ASC(Toets$)
		 
			CASE IS = 2
				Toets% = 255 + ASC(RIGHT$(Toets$, 1))
			 
			CASE ELSE
				Toets% = 0

		END SELECT

END SUB

DEFINT A-Z
SUB CheckSidValids

		LOCATE CSRLIN + 1, 2

		St$ = "Stripping NON-psid files..."

		PLACE 2, CSRLIN + 1, "box", St$, TextColor%
	 
		PRINT
 
		FOR PsidFile& = 1 TO FileLines&
	 
		Catch% = 1
		
		TempHandler% = 1
		 
		
		C64MusicFile$ = GetReeks$(PsidFile&)

		getsonginfo
	
		IF UCASE$(PsidInfo$) = "PSID" THEN
			TempHandler% = 2
		
			LinePos& = LinePos& + 1

			Liner$ = SongName$ + SongAuthor$ + SongCopyright$ + STR$(LinePos&)
			 
			PutReeks Liner$, PsidFile&
			 
			Valid& = Valid& + 1
		ELSE
			Invalid$ = STRING$(Leng%, " ")
			
			PutReeks Invalid$, PsidFile&
		END IF
		
		Percent% = CLNG(PsidFile& / FileLines& * 100)
		
		Progress Percent%, 4
	 
		CheckInkey

		Cancel

		Quit
	NEXT PsidFile&
 
	Pbar% = 0
 
	Invalid$ = ""
 
	C64MusicFile$ = ""

	TempFile% = FREEFILE
 
	OPEN OwnPath$ + "MAINARCH.SFN" FOR OUTPUT AS #TempFile%
 
	TempData% = FREEFILE
 
	OPEN OwnPath$ + ExeFile$ + ".IDB" FOR BINARY AS #TempData%

	IF LOF(TempData%) > 0 THEN
		CLOSE #TempData%
	 
		KILL OwnPath$ + ExeFile$ + ".IDB"
	 
		OPEN OwnPath$ + ExeFile$ + ".IDB" FOR BINARY AS #TempData%
	END IF

	LengX% = 0
 
	LOCATE CSRLIN + 1, 2

	St$ = "Saving the stuff..."

	PLACE 2, CSRLIN + 1, "box", St$, TextColor%
 
	PRINT

	FOR PsidFile& = 1 TO FileLines&
		Catch% = 1
	 
		TempHandler% = 1
		
		ValidFile$ = GetReeks$(PsidFile&)
	 
		IF ValidFile$ <> "" THEN
	 
			IF LEN(ValidFile$) > LengX% THEN
				LengX% = LEN(ValidFile$)
			END IF

			TempHandler% = 2

			ValidData$ = GetReeks$(PsidFile&)
		 
			ValidNumber$ = MID$(ValidData$, 97)
		 
			ValidData$ = LEFT$(ValidData$, 96)
		 
			VNumber& = VAL(ValidNumber$)

			PRINT #TempFile%, ValidFile$
		 
			PUT #TempData%, LOC(TempData%) + 1, ValidData$
		 
			PUT #TempData%, LOC(TempData%) + 1, VNumber&
	 
			ValidSidFile& = ValidSidFile& + 1
		END IF

		HadLen& = PsidFile& + 2
	
		Percent% = CLNG(HadLen& / FileLines& * 100)

		Progress Percent%, 4
	
		CheckInkey

		Cancel

		Quit
	NEXT PsidFile&

	Pbar% = 0
 
	FileLines& = ValidSidFile&

	Leng% = LengX%
 
	IniFile% = FREEFILE
 
	OPEN OwnPath$ + ExeFile$ + ".INI" FOR INPUT AS #IniFile%
 
	IniFileOut% = FREEFILE
 
	OPEN OwnPath$ + ExeFile$ + ".BNI" FOR OUTPUT AS #IniFileOut%
	
	DO WHILE NOT EOF(IniFile%)
		LINE INPUT #IniFile%, A$
	 
		NowLine% = NowLine% + 1
	 
		IF NowLine% = 4 THEN
			PRINT #IniFileOut%, LTRIM$(RTRIM$(STR$(FileLines&)))
		ELSE
			IF NowLine% = 5 THEN
				PRINT #IniFileOut%, LTRIM$(RTRIM$(STR$(Leng%)))
			ELSE
				PRINT #IniFileOut%, A$
			END IF

		END IF

	LOOP

	CLOSE #IniFile%
 
	CLOSE #IniFileOut%
 
	KILL OwnPath$ + ExeFile$ + ".INI"
 
	NAME OwnPath$ + ExeFile$ + ".BNI" AS OwnPath$ + ExeFile$ + ".INI"
 
	SHELL "copy " + OwnPath$ + ExeFile$ + ".INI " + OwnPath$ + ExeFile$ + ".BCK>nul"
END SUB

SUB ClearIni
			FillViewPort
		
			LOCATE 8, (82 - LEN("Restart and re-enter path-information again.")) \ 2
		
			Startm% = ((CSRLIN - 1) * 16) - 2
		
			ZetPointerUit
		
			COLOR TextColorBox%

			PRINT "Hmmz, your configurationfile looks damaged. "
		
			LOCATE CSRLIN, (82 - LEN("Restart and re-enter path-information again.")) \ 2
		
			PRINT "Precautional measures taken...:             "
		
			LOCATE CSRLIN, (82 - LEN("Restart and re-enter path-information again.")) \ 2
		
			PRINT "Restart and re-enter path-information again."
		
			LOCATE CSRLIN, (82 - LEN("Restart and re-enter path-information again.")) \ 2
		
			BorderLinesBox 142, Startm%, 44, 3
	 
			CLOSE
	 
			KILL OwnPath$ + ExeFile$ + ".INI"
		
			SHELL "copy " + OwnPath$ + ExeFile$ + ".BCK " + OwnPath$ + ExeFile$ + ".INI>nul"
		
			St$ = "Ending procedure initialized..."
		
			PLACE ((82 - LEN("Ending procedure initialized...")) \ 2), CSRLIN + 2, "BOX", St$, TextColor%
		
			PRINT

			ShowOkButton ((78 - 20) \ 2), 14
		
			SCREEN 0

			Terminate
END SUB

SUB ControlCentre STATIC

	DIM Ttle$(1 TO 15)
	DIM Athor$(1 TO 15)
	DIM Cright$(1 TO 15)

	StartReeks& = 0
 
	Stock% = 1
 
	HuidigePointer% = 1

	BuildControlScreen

	LOCATE 3, WindowX%
 
	SELECT CASE FileLines&
			
		CASE IS >= 15
			MaximumWindowsTerritory% = 15
		 
		CASE IS < 15
			MaximumWindowsTerritory% = FileLines&
		
	END SELECT

 
	DO
	 
		SELECT CASE NoChangeMade%
		 
			CASE IS = 0
			 
				LOCATE 3, WindowX%

				FOR I& = 1 TO MaximumWindowsTerritory%
					Ttle$(I&) = GetReeks$(I& + StartReeks&)
				 
					DO WHILE INSTR(Ttle$(I&), CHR$(0)) > 0
						MID$(Ttle$(I&), INSTR(Ttle$(I&), CHR$(0)), 1) = " "
					LOOP
				 
					Athor$(I&) = MID$(Ttle$(I&), 33, 32)
			 
					Cright$(I&) = MID$(Ttle$(I&), 65, 32)
			 
					Choosen% = VAL(MID$(Ttle$(I&), 101, 1))
				
					Ttle$(I&) = LEFT$(Ttle$(I&), 32)
			 
					LOCATE CSRLIN, WindowX%
				 
					IF I& <> HuidigePointer% THEN
					 
						IF Choosen% = 1 THEN
							COLOR ChoiceColor%
						ELSE
							COLOR TextColorBox%
						END IF

						IF Stock% = 1 THEN
							PRINT Athor$(I&); Ttle$(I&)
						ELSE
							PRINT Ttle$(I&); Cright$(I&)
						END IF
					 
						MainPos% = CSRLIN
					ELSE
					 
						IF Stock% = 1 THEN
							St$ = Athor$(I&) + Ttle$(I&)
						ELSE
							St$ = Ttle$(I&) + Cright$(I&)
						END IF
					 
						IF Choosen% = 1 THEN
							PLACE WindowX%, CSRLIN, "nothing", St$, HighLightColor%
						ELSE
							PLACE WindowX%, CSRLIN, "nothing", St$, TextColor%
						END IF
					 
						EigenX& = HuidigePointer% + StartReeks&

						TempHandler% = 2
			 
						Eigen$ = GetReeks$(EigenX&)
				
						FilePntr& = CVL(MID$(Eigen$, 97, 4))
				
						TempHandler% = 1
				
						FileNme$ = GetReeks$(FilePntr&)
				 
						TempHandler% = 2
				
						IF Leng% > 78 THEN
							St$ = RIGHT$(FileNme$, 78)
						 
							St$ = St$ + STRING$(78 - LEN(St$), " ")
						 
							FileMid% = 2
						ELSE
							St$ = FileNme$ + STRING$(Leng% - LEN(FileNme$), " ")
						 
							FileMid% = (78 - 50) \ 2
						END IF
					 
					END IF

				NEXT I&
	 
			CASE 2
				I& = HuidigePointer% - 10
			 
				SmallChange% = 1
		 
			CASE 3
				I& = HuidigePointer% + 10
			
				SmallChange% = 1
		 
			CASE 4
				I& = HuidigePointer% - 1
		 
				SmallChange% = 1
		 
			CASE 5
				I& = HuidigePointer% + 1
		 
				SmallChange% = 1
			CASE 6, 7
				I& = OldPointer%
		
				SmallChange% = 1
	 
		END SELECT

		IF SmallChange% = 1 THEN
		 
			DO
				
				Ttle$(I&) = GetReeks$(I& + StartReeks&)
			 
				DO WHILE INSTR(Ttle$(I&), CHR$(0)) > 0
					MID$(Ttle$(I&), INSTR(Ttle$(I&), CHR$(0)), 1) = " "
				LOOP
			 
				Athor$(I&) = MID$(Ttle$(I&), 33, 32)
		 
				Cright$(I&) = MID$(Ttle$(I&), 65, 32)
		 
				Choosen% = VAL(MID$(Ttle$(I&), 101, 1))
			
				Ttle$(I&) = LEFT$(Ttle$(I&), 32)
		 
				IF I& <> HuidigePointer% THEN
				
					IF Choosen% = 1 THEN
						COLOR ChoiceColor%
					ELSE
						COLOR TextColorBox%
					END IF
				 
					LOCATE I& + 2, WindowX%
					
					IF Stock% = 1 THEN
						PRINT Athor$(I&); Ttle$(I&)
					ELSE
						PRINT Ttle$(I&); Cright$(I&)
					END IF
				 
'          MainPos% = CSRLIN
				ELSE
				 
					IF Stock% = 1 THEN
						St$ = Athor$(I&) + Ttle$(I&)
					ELSE
						St$ = Ttle$(I&) + Cright$(I&)
					END IF
				 
					IF Choosen% = 1 THEN
						PLACE WindowX%, I& + 2, "nothing", St$, HighLightColor%
					ELSE
						PLACE WindowX%, I& + 2, "nothing", St$, TextColor%
					END IF
				 
					EigenX& = HuidigePointer% + StartReeks&

					TempHandler% = 2
		 
					Eigen$ = GetReeks$(EigenX&)
			
					FilePntr& = CVL(MID$(Eigen$, 97, 4))
			
					TempHandler% = 1
			
					FileNme$ = GetReeks$(FilePntr&)
			 
					TempHandler% = 2
			
					IF Leng% > 78 THEN
						St$ = RIGHT$(FileNme$, 78)
					 
						St$ = St$ + STRING$(78 - LEN(St$), " ")
					
						FileMid% = 2
					ELSE
						St$ = FileNme$ + STRING$(Leng% - LEN(FileNme$), " ")
					 
						FileMid% = (78 - 50) \ 2
					END IF
				
				END IF
				
				IF I& = HuidigePointer% THEN
					EXIT DO
				ELSE
					I& = HuidigePointer%
				END IF

			LOOP
		 
			SmallChange% = 0
		END IF

		IF NoChangeMade% <> 1 THEN
			MainPos% = CSRLIN

			PLACE FileMid%, 21, "box", St$, TextColor%
					
			PRINT
		 
			Iplaats& = StartReeks& + HuidigePointer%
	
			St$ = RTRIM$(LTRIM$(STR$(Iplaats&)))
		
			IF LEN(St$) < 6 THEN
				St$ = STRING$(6 - LEN(St$), "0") + St$
			END IF

			PLACE WindowX% + 5, 19, "box", St$, TextColor%
		 
			LOCATE MainPos%, WindowX%
		END IF


		CheckInkey
	 
		IF Toets% <> 0 THEN
			St$ = "Status:Groovy..."

			StatusLine "box", St$, TextColor%
		 
			NoChangeMade% = 0
		END IF

		SELECT CASE Toets%
		 
			CASE 27
				EXIT DO

			CASE 330, 332, 9
			 
				SELECT CASE Stock%
				 
					CASE 1
						Stock% = 2
				 
					CASE 2
						Stock% = 1
			 
				END SELECT
		 
			CASE 327
			 
				IF HuidigePointer% - 1 < 1 THEN
				 
					IF StartReeks& - 1 < 0 THEN
					 ' StartReeks& = 0
						NoChangeMade% = 1
					ELSE
						StartReeks& = StartReeks& - 1
					END IF
			 
				ELSE
					NoChangeMade% = 5

					HuidigePointer% = HuidigePointer% - 1
				END IF
		 
			CASE 335
			 
				IF HuidigePointer% + 1 > MaximumWindowsTerritory% THEN
				 
					IF StartReeks& + 16 > FileLines& THEN
					'  StartReeks& = FileLines& - MaximumWindowsTerritory%
						NoChangeMade% = 1
					ELSE
						StartReeks& = StartReeks& + 1
					END IF
				 
				ELSE
					NoChangeMade% = 4
				 
					HuidigePointer% = HuidigePointer% + 1
				END IF
		 
			CASE 328
			 
				IF HuidigePointer% = 1 AND StartReeks& = 0 THEN
					NoChangeMade% = 1
				END IF
			 
				IF HuidigePointer% - 10 < 1 THEN
				
					HuidigePointer% = 1
				 
					Differ% = ABS(HuidigePoint% - 10)
				 
					IF StartReeks& - Differ% < 0 THEN
						StartReeks& = 0
					ELSE
						StartReeks& = StartReeks& - Differ%
					END IF
					
				ELSE
					NoChangeMade% = 3

					HuidigePointer% = HuidigePointer% - 10
				END IF
		 
			CASE 336
			 
				IF HuidigePointer% = MaximumWindowsTerritory% AND StartReeks& = (FileLines& - MaximumWindowsTerritory%) THEN
					NoChangeMade% = 1
				END IF

				IF HuidigePointer% + 10 > MaximumWindowsTerritory% THEN
				
					Differ% = HuidigePointer% + 10 - MaximumWindowsTerritory%
				 
					HuidigePointer% = MaximumWindowsTerritory%

					IF StartReeks& + Differ% + 16 > FileLines& THEN
						StartReeks& = FileLines& - MaximumWindowsTerritory%
					ELSE
						StartReeks& = StartReeks& + Differ%
					END IF
			
				ELSE
					NoChangeMade% = 2

					HuidigePointer% = HuidigePointer% + 10
				END IF
		 
			CASE 326
			 
				IF HuidigePointer% <> 1 THEN
					OldPointer% = HuidigePointer%

					HuidigePointer% = 1
				 
					NoChangeMade% = 6
				ELSE
					NoChangeMade% = 1
				END IF

			CASE 334
				IF HuidigePointer% <> MaximumWindowsTerritory% THEN
					OldPointer% = HuidigePointer%

					HuidigePointer% = MaximumWindowsTerritory%
				 
					NoChangeMade% = 7
				ELSE
					NoChangeMade% = 1
				END IF
		 
			CASE 374
					IF HuidigePointer% <> 1 AND StartReeks& <> 0 OR StartReeks& <> 0 OR HuidigePointer% <> 1 THEN
						StartReeks& = 0
				 
						HuidigePointer% = 1
					ELSE
						NoChangeMade% = 1
					END IF
			CASE 372
				EndCalc& = FileLines& - MaximumWindowsTerritory%
			 
					IF HuidigePointer% <> MaximumWindowsTerritory% AND StartReeks& <> EndCalc& OR StartReeks& <> EndCalc& OR HuidigePointer% <> MaximumWindowsTerritory% THEN
						StartReeks& = EndCalc&
			
						HuidigePointer% = MaximumWindowsTerritory%
					ELSE
						NoChangeMade% = 1
					END IF
			CASE 32
				SwitchPointer& = HuidigePointer% + StartReeks&
			 
				SwitchVal$ = GetReeks$(SwitchPointer&)
			 
				IF MID$(SwitchVal$, 101, 1) <> "1" THEN
					MID$(SwitchVal$, 101, 1) = "1"
				ELSE
					MID$(SwitchVal$, 101, 1) = "0"
				END IF

				PutReeks SwitchVal$, SwitchPointer&
		 
				IF HuidigePointer% + 1 > MaximumWindowsTerritory% THEN
				 
					IF StartReeks& + MaximumWindowsTerritory% > FileLines& THEN
						StartReeks& = FileLines& - MaximumWindowsTerritory%
					ELSE
						IF FileLines& > 15 THEN
							StartReeks& = StartReeks& + 1
						END IF
					END IF
			 
				ELSE
					HuidigePointer% = HuidigePointer% + 1
				END IF
		 
			CASE 13
				St$ = ""

				StatusLine "box", St$, TextColor%
			 
				EigenX& = HuidigePointer% + StartReeks&

				TempHandler% = 2
			
				Eigen$ = GetReeks$(EigenX&)
			 
				FilePntr& = CVL(MID$(Eigen$, 97, 4))
			 
				TempHandler% = 1
			 
				FileNme$ = GetReeks$(FilePntr&)
				
				TempHandler% = 2
			 
				IF SidPlayPath$ = "Disabled" THEN
					St$ = "Sidplay path not set!"

					StatusLine "box", St$, TextColor%
				ELSE
					SHELL SidPlayPath$ + " " + FileNme$
				END IF
			 
				NoChangeMade% = 1
			CASE 103, 289
				St$ = "Enter value between 1 and" + STR$(FileLines&)

				StatusLine "box", St$, TextColor%
			
				LOCATE 24, LEN("[G]o to:") + 3

				Startm% = ((CSRLIN) * 16) - 2

				BorderLinesBox (((LEN("[G]o to:") + 2) * 8) - 2), Startm%, 6, 1

				Yer% = 25

				Xer% = LEN("[G]o to:") + 3
	 
				ZetPointerAan
	
				StuurToets Xer%, Yer%, "nothing", GotoLine$, 6

				IF VAL(GotoLine$) > 0 THEN
					St$ = "Jumping..."

					StatusLine "box", St$, TextColor%
				 
					IF VAL(GotoLine$) <= FileLines& THEN

						IF VAL(GotoLine$) >= FileLines& - MaximumWindowsTerritory% THEN
							HuidigePointer% = MaximumWindowsTerritory%

							StartReeks& = VAL(GotoLine$) - MaximumWindowsTerritory%
						ELSE
						 
							IF VAL(GotoLine$) <= MaximumWindowsTerritory% THEN
								HuidigePointer% = VAL(GotoLine$)
							 
								StartReeks& = 0
							ELSE
								HuidigePointer% = 7

								StartReeks& = VAL(GotoLine$) - 7
							END IF
					 
						END IF
					 
						St$ = "Status:Groovy..."

						StatusLine "box", St$, TextColor%

					ELSE
						St$ = "Invalid linenumber:from 1 to" + STR$(FileLines&) + " only please."

						StatusLine "box", St$, TextColor%
					END IF
				ELSE
					St$ = "Status:Groovy..."

					StatusLine "box", St$, TextColor%
				 
					NoChangeMade% = 1
				END IF
		

			CASE 115, 286
				InsertSearchKey Search$
			
				StartPoint& = 1

				IF Search$ = CHR$(27) THEN
					St$ = "Status:Groovy..."

					StatusLine "box", St$, TextColor%
				 
					Search$ = ""
				 
					NoChangeMade% = 1
				END IF

				IF Search$ <> "" THEN
					TempHandler% = 2

					St$ = "Searching..."

					StatusLine "box", St$, TextColor%
		
					FoundIt% = 0

					FOR Searcher& = StartPoint& TO FileLines&
						SearchCompare$ = LCASE$(GetReeks$(Searcher&))
					 
						IF INSTR(SearchCompare$, Search$) > 0 THEN
							St$ = "Key found!"

							StatusLine "box", St$, TextColor%
						 
							FoundIt% = 1
						 
							TempX$ = MID$(SearchCompare$, 33, 32)
						 
							IF INSTR(TempX$, Search$) > 0 THEN
								Stock% = 1
							END IF

							TempX$ = MID$(SearchCompare$, 65, 32)
						 
							IF INSTR(TempX$, Search$) > 0 THEN
								Stock% = 2
							END IF
						 
						 
							SELECT CASE Searcher&
						 
								CASE IS < 7
									HuidigePointer% = Searcher&

									StartReeks& = 0
							
								CASE IS > FileLines& - 7
									HuidigePointer% = MaximumWindowsTerritory% - (FileLines& - Searcher&)

									StartReeks& = FileLines& - MaximumWindowsTerritory%
							 
								CASE IS > 7, IS < FileLines& - 7
									HuidigePointer% = 7

									StartReeks& = Searcher& - 7
						 
						
							END SELECT
						 
							EXIT FOR
						END IF

					' PRINT Search$
				 
					NEXT Searcher&
				 
					IF FoundIt% = 0 THEN
						St$ = "Sorry, string not found."

						StatusLine "box", St$, TextColor%
					 
						NoChangeMade% = 1
					 
						Search$ = ""
					END IF
			 
				ELSE
					St$ = "Status:Groovy..."

					StatusLine "box", St$, TextColor%
				 
					NoChangeMade% = 1
				END IF
		 
			CASE 316
				IF Search$ <> "" THEN
					St$ = "Continue search..."

					StatusLine "box", St$, TextColor%
				 
					StartPoint& = (HuidigePointer% + 1 + StartReeks&)
				ELSE
					InsertSearchKey Search$

				 
					IF Search$ = CHR$(27) THEN
						St$ = "Status:Groovy..."

						StatusLine "box", St$, TextColor%
				
						Search$ = ""
				
						NoChangeMade% = 1
					 
						StartPoint& = 1
					END IF
			 
				END IF

				IF Search$ <> "" THEN
					TempHandler% = 2

					FoundIt% = 0

					FOR Searcher& = StartPoint& TO FileLines&
						SearchCompare$ = LCASE$(GetReeks$(Searcher&))
					
						IF INSTR(SearchCompare$, Search$) > 0 THEN
							St$ = "Key found!"

							StatusLine "box", St$, TextColor%
						
							FoundIt% = 1

							LastPosition& = Searcher& + 1
						
							IF INSTR(MID$(SearchCompare$, 33, 32), Search$) > 0 THEN
								Stock% = 1
							END IF

							IF INSTR(MID$(SearchCompare$, 65, 32), Search$) > 0 THEN
								Stock% = 2
							END IF
						 
							SELECT CASE Searcher&
							 
								CASE IS < 7
									HuidigePointer% = Searcher&

									StartReeks& = 0
							 
								CASE IS > FileLines& - 7
									HuidigePointer% = MaximumWindowsTerritory% - (FileLines& - Searcher&)

									StartReeks& = FileLines& - MaximumWindowsTerritory%
							 
								CASE IS > 7, IS < FileLines& - 7
									HuidigePointer% = 7

									StartReeks& = Searcher& - 7
						 
							END SELECT

							EXIT FOR
						END IF

					' PRINT Search$
				
					NEXT Searcher&
				 
					IF FoundIt% = 0 THEN
						St$ = "Sorry, string not found."

						StatusLine "box", St$, TextColor%
					 
						NoChangeMade% = 1

						Search$ = ""
					END IF
			 
				ELSE
					St$ = "Status:Groovy..."

					StatusLine "box", St$, TextColor%
				
					NoChangeMade% = 1
				END IF

			CASE 314
				ShowControlHelp
			 
				BuildControlScreen

			CASE 315
				ShowConfiguration
			
				BuildControlScreen

			CASE ELSE
				NoChangeMade% = 1

		END SELECT

		LOCATE 3, WindowX%
	
	LOOP

END SUB

SUB CountPSIDFiles (InputFile$)
	UploadFile% = FREEFILE

	OPEN InputFile$ FOR INPUT AS #UploadFile%

	LOCATE CSRLIN + 1, 2

	St$ = "Processing first file-check..."
 
	PLACE 2, CSRLIN + 1, "box", St$, TextColor%

	PRINT

	DO WHILE NOT EOF(UploadFile%)
		LINE INPUT #UploadFile%, A$

		HadLen& = HadLen& + LEN(A$) + 2
	
		Percent% = CLNG(HadLen& / LOF(UploadFile%) * 100)

		Progress Percent%, 4
	 
		FileLines& = FileLines& + 1

		IF LEN(A$) > Leng% THEN
			Leng% = LEN(A$)
		END IF

	LOOP

	Leng% = Leng% + 1

	CLOSE #UploadFile%
 
	Pbar% = 0
END SUB

DEFSNG A-Z
SUB CreateBorders
	SubSource$ = UCASE$("CreateBorders")
 
	SCREEN 12
 
	LINE (0, 0)-(640, 0), 15
	LINE (0, 0)-(0, 480), 15
	LINE (1, 1)-(638, 1), 15
	LINE (1, 1)-(1, 478), 15
	LINE (639, 1)-(639, 479), 8
	LINE (1, 479)-(639, 479), 8

END SUB

SUB FillCenter
	SubSource$ = UCASE$("FillCenter")

	LINE (2, 2)-(637, 477), BackGroundColor%, BF
 
	St$ = "SidBase V2.51 uggy version by Vincent Voois"

	LOCATE 1, 19

	ShowChars St$, TextColor%

	CreateBorders

	LOCATE 2, 2

END SUB

SUB FillRect (Xa%, Ya%, Xb%, Yb%)
	SubSource$ = UCASE$("FillRect")
 
	LINE (Xa%, Ya%)-(Xb%, Yb%), BackGroundColor%, BF

END SUB

DEFINT A-Z
SUB FillViewPort
	LINE (2, 15)-(637, 477), BackGroundColor%, BF

	LOCATE 3, 2
END SUB

DEFSNG A-Z
SUB GetRootFileInfo
	SubSource$ = UCASE$("getrootfileinfo")

	ExeFile$ = LEFT$(FullPath$, LEN(FullPath$) - 4)

	OwnPath$ = ExeFile$

	DO
		OwnPath$ = LEFT$(OwnPath$, LEN(OwnPath$) - 1)
	LOOP UNTIL RIGHT$(OwnPath$, 1) = "\"

	ExeFile$ = RIGHT$(ExeFile$, LEN(ExeFile$) - LEN(OwnPath$))
 
	'*-removal-*
	' The following lines are for testpurposes only:they will get removed when
	' the final release will get compiled

	'OwnPath$ = "D:\test\"
 
	'ExeFile$ = "sidbase"
 
	'*-removal-*

END SUB

SUB getsonginfo
	SubSource$ = UCASE$("getsonginfo")

	ON ERROR GOTO Fout
 
	MusicFile% = FREEFILE

	OPEN C64MusicFile$ FOR BINARY AS #MusicFile%

	PsidInfo$ = "    "
	Loadad$ = "      "
	Initad$ = "  "
	Playad$ = "  "
	SongTotal$ = "  "
	SongStart$ = "  "
	SongSpeed$ = "    "
	SongName$ = STRING$(32, " ")
	SongAuthor$ = STRING$(32, " ")
	SongCopyright$ = STRING$(32, " ")
	SidSong$ = "   "
	LoadRubbish$ = " "

	GET #MusicFile%, 1, PsidInfo$
	GET #MusicFile%, LOC(MusicFile%) + 1, Loadad$
	GET #MusicFile%, LOC(MusicFile%) + 1, Initad$
	GET #MusicFile%, LOC(MusicFile%) + 1, Playad$
	GET #MusicFile%, LOC(MusicFile%) + 1, SongTotal$
	GET #MusicFile%, LOC(MusicFile%) + 1, SongStart$
	GET #MusicFile%, LOC(MusicFile%) + 1, SongSpeed$
	GET #MusicFile%, LOC(MusicFile%) + 1, SongName$
	GET #MusicFile%, LOC(MusicFile%) + 1, SongAuthor$
	GET #MusicFile%, LOC(MusicFile%) + 1, SongCopyright$
	GET #MusicFile%, LOC(MusicFile%) + 1, SidSong$

	FOR I = 1 TO 2
		TempIn$ = TempIn$ + HEX$(ASC(MID$(Initad$, I, 1)))
	NEXT I

	Initad$ = TempIn$

	TempIn$ = ""

	FOR I = 1 TO 2
		TempIn$ = TempIn$ + HEX$(ASC(MID$(Playad$, I, 1)))
	NEXT I

	Playad$ = TempIn$

	TempIn$ = ""

	FOR I = 1 TO 2
		Kappy$ = STR$(ASC(MID$(SongTotal$, I, 1)))
	
		Stb$ = Stb$ + LTRIM$(RTRIM$(Kappy$))
	NEXT I

	SongTotal$ = Stb$

	Stb$ = ""

	FOR I = 1 TO 2
		Kappy$ = STR$(ASC(MID$(SongStart$, I, 1)))

		Stb$ = Stb$ + LTRIM$(RTRIM$(Kappy$))
	NEXT I

	SongStart$ = Stb$

	Stb$ = ""

	FOR I = 1 TO 4
		Kappy$ = STR$(ASC(MID$(SongSpeed$, I, 1)))

		Stb$ = Stb$ + LTRIM$(RTRIM$(Kappy$))
	NEXT I

	SongSpeed$ = Stb$

	Stb$ = ""
 
	CLOSE #MusicFile%

END SUB

DEFINT A-Z
SUB InsertSearchKey (Search$)
			 
	St$ = "Inserting searchkey..."
 
	StatusLine "box", St$, TextColor%
 
	LOCATE 26, LEN("[S]earch:") + 3
 
	Startm% = ((CSRLIN) * 16) - 2
 
	BorderLinesBox (((LEN("[S]earch:") + 2) * 8) - 2), Startm%, 32, 1
 
	Yer% = 27
 
	Xer% = LEN("[S]earch:") + 3
 
	ZetPointerAan
 
	StuurToets Xer%, Yer%, "nothing", Search$, 32

	Search$ = LCASE$(Search$)
END SUB

SUB IntegrityCheck (CorruptedLink&, MissingLink&, NotUpdatedLink&, WrongLink&)
	SFNFile% = FREEFILE
 
	OPEN OwnPath$ + "MAINARCH.SFN" FOR INPUT AS SFNFile%
 
	IDBFile% = FREEFILE
 
	OPEN OwnPath$ + ExeFile$ + ".IDB" FOR BINARY AS IDBFile% LEN = 100

	LinePos& = 1
 
	DO WHILE NOT EOF(SFNFile%)
		LINE INPUT #SFNFile%, A$
	 
		C64MusicFile$ = A$
	 
		IdbPosition& = LOC(IDBFile%) + 1
	 
		GET #IDBFile%, LOC(IDBFile%) + 1, Cp$
		
		getsonginfo
	 
		IF UCASE$(PsidInfo$) <> "PSID" THEN
			CorruptedLink& = CorruptedLink& + 1
		 
			CpB$ = "Link to corrupted PSID file"
			CpB$ = CpB$ + STRING$(32 - LEN(CpB$), " ")
			CpB$ = "or wrong link to nonexisting or"
			CpB$ = CpB$ + STRING$(32 - LEN(CpB$), " ")
			CpB$ = "wrongly named file"
			CpB$ = CpB$ + STRING$(32 - LEN(CpB$), " ")
			 
			PUT #IDBFile%, IdbPosition&, CpB$
		 
			PUT #IDBFile%, LOC(IDBFile%) + 1, LinePos&
		ELSE
			CpB$ = SongName$ + SongAuthor$ + SongCopyright$
		 
			IF LEFT$(Cp$, 96) <> CpB$ THEN
				WrongLink& = WrongLink& + 1
			 
				PUT #IDBFile%, IdbPosition&, CpB$
			 
				PUT #IDBFile%, LOC(IDBFile%) + 1, LinePos&
			END IF

		END IF
 
	LinePos& = LinePos& + 1

	LOOP
END SUB

SUB MarkArea (X%, Y%, TextLines%, TLineLen%, Type$, Empty%)
 
	Pixl% = 8 * X% - 2
 
	Piyl% = 16 * Y% - 2
 
	Tlen! = TLineLen%
 
	LOCATE Y%, X%

	SELECT CASE UCASE$(Type$)

		CASE IS = "BUTTON", "NOTHING"
			COLOR TextColor%
	
		CASE ELSE
			COLOR TextColorBox%

	END SELECT

	SELECT CASE UCASE$(Type$)

		CASE IS = "BUTTON"
			BorderLinesButton Pixl%, Piyl%, Tlen!, TextLines%
		
			FillRect Pixl% + 1, Piyl% + 1, Pixl% + (TLineLen% * 8) + 1, TextLines% * Piyl% + 17
		
			ShowChars St$, MainColor%
	
		CASE IS = "BOX"
			BorderLinesBox Pixl%, Piyl%, Tlen!, TextLines%
																											
			IF Empty% = 1 THEN
				LINE (Pixl% + 2, Piyl% + 2)-(Pixl% + (Tlen! * 8) + 1, Piyl% + (16 * TextLines%) + 1), 0, BF
			END IF
	 
		CASE IS = "SWITCHBOX"
			BorderLinesBox Pixl%, Piyl%, Tlen!, TextLines%

			FillRect Pixl% + 1, Piyl% + 1, Pixl% + (TLineLen% * 8) + 1, TextLines% * Piyl% + 17
		
		CASE ELSE
			FillRect Pixl% + 1, Piyl% + 1, Pixl% + (TLineLen% * 8) + 1, TextLines% * Piyl% + 17
	 
	END SELECT

END SUB

DEFSNG A-Z
SUB PLACE (Xl%, Yl%, Type$, St$, MainColor%)
	SubSource$ = UCASE$("PLACE")
 
	Pixl% = (Xl% * 8) - 10
 
	Piyl% = (Yl% * 16) - 18
 
	WordLen! = LEN(St$)
 
	LOCATE Yl%, Xl%
 
	SELECT CASE UCASE$(Type$)

		CASE IS = "BUTTON", "NOTHING"
			COLOR MainColor%
	 
		CASE ELSE
			COLOR TextColorBox%
 
	END SELECT

	SELECT CASE UCASE$(Type$)

		CASE IS = "BUTTON"
			BorderLinesButton Pixl%, Piyl%, WordLen!, 1
		 
			FillRect Pixl% + 1, Piyl% + 1, Pixl% + (LEN(St$) * 8) + 1, Piyl% + 17
		 
			ShowChars St$, MainColor%
	 
		CASE IS = "BOX"
			PRINT St$;

			BorderLinesBox Pixl%, Piyl%, WordLen!, 1
	 
		CASE IS = "SWITCHBOX"
			BorderLinesBox Pixl%, Piyl%, WordLen!, 1

			FillRect Pixl% + 1, Piyl% + 1, Pixl% + (LEN(St$) * 8) + 1, Piyl% + 17
		 
			ShowChars St$, MainColor%

		CASE ELSE
			FillRect Pixl% + 2, Piyl% + 2, Pixl% + (LEN(St$) * 8) + 1, Piyl% + 17
		
			ShowChars St$, MainColor%
 
	END SELECT

END SUB

SUB Progress (Percent%, Kleur%)
	SubSource$ = UCASE$("progress")

	IF INSTR(COMMAND$, "/P0") > 0 THEN
		EXIT SUB
	END IF

	IF Percent% < Higher% THEN
		Higher% = 0
	END IF

	IF Pbar% = 0 THEN
		Pbar% = CSRLIN + 1
	END IF

	IF Percent% > 0 THEN
	 
		IF Percent% > Higher% AND Percent% < 101 THEN
			Higher% = Percent%
		 
			Start% = (Pbar% * 16) - 2
	 
			PercentLine% = Pbar%
	 
			Startm% = ((PercentLine% + 2) * 16) - 2

			IF INSTR(COMMAND$, "/P1") = 0 THEN
				ZetPointerUit
		 
				BorderLinesBox 18, Start%, 75.4, 1

				FOR Teller% = 1 TO Percent%
					LINE (20 + Teller%, Start% + 3)-(20 + Teller% * 6, Start% + 16), Kleur%, BF
				NEXT Teller%
		 
				ZetPointerAan
			END IF

			St$ = STR$(Percent%)
		
			St$ = LTRIM$(RTRIM$(St$))
		 
			IF LEN(St$) < 3 THEN
				St$ = STRING$(3 - LEN(St$), " ") + St$
			END IF
		 
			St$ = St$ + " %"
		 
			PercentX% = (80 - LEN(St$)) \ 2
		 
			PercentPix% = ((PercentX% * 16) \ 2) - 10
		 
			ZetPointerUit
		 
			PLACE PercentX%, PercentLine% + 3, "box", St$, TextColor%
		 
			PRINT

			ZetPointerAan
		END IF

	END IF
	
END SUB

SUB Quit STATIC
	SubSource$ = UCASE$("Quit")
 
		St$ = "Quit"
	 
		IF QuitButton% = 0 THEN
			PLACE 2, 28, "BUTTON", St$, TextColor%
		 
			QuitButton% = 1
		END IF
 
		ZetPointerAan
	 
		LeesMuisIo Button%, Mx%, My%
	 
		IF Button% = 1 OR Toets% = 271 AND Locked% = 0 THEN
	
			IF (Mx% >= 8 AND Mx% <= 38) AND (My% >= 432 AND My% <= 447) AND QStarter% = 0 OR Toets% = 271 AND Locked% = 0 THEN
				Toets$ = ""

				ZetPointerUit
			 
				PLACE 2, 28, "switchBOX", St$, TextColor%
			 
				QStarter% = 1
			 
				Locked% = 1
			END IF
	
		ELSE
	
			IF QStarter% = 1 AND Toets% = 0 AND Locked% = 1 THEN
				ZetPointerUit
 
				PLACE 2, 28, "button", St$, TextColor%
		 
				Terminate
			ELSE
				QStarter% = 0
			 
				IF Locked% = 1 THEN
					ZetPointerUit

					PLACE 2, 28, "button", St$, TextColor%
				 
					Locked% = 0
				END IF

			END IF
	
		END IF
	 
END SUB

SUB ReadChars
	SubSource$ = UCASE$("ReadChars")

	OPEN OwnPath$ + "default.fnt" FOR BINARY AS #1

	Range% = 0

	GET #1, LOC(1) + 1, Range%

	Fonts$ = STRING$(LOF(1) - 2, CHR$(0))
 
	GET #1, LOC(1) + 1, Fonts$

	CLOSE

	Optiva% = 33

	End$ = CHR$(0) + CHR$(0)
 
	DO
		
		IF INSTR(Fonts$, End$) > 0 THEN
		 
			CharsPos$(Optiva%) = LEFT$(Fonts$, INSTR(Fonts$, End$) - 1)
		 
			Fonts$ = RIGHT$(Fonts$, LEN(Fonts$) - LEN(CharsPos$(Optiva%)) - 2)
		 
			Optiva% = Optiva% + 1
		ELSE
			EXIT DO
		END IF
	
	LOOP
 
	CLOSE

END SUB

SUB RetrieveSongDatas
	SubSource$ = UCASE$("retrievesongdatas")

	CLOSE

	OPEN OwnPath$ + "MAINARCH.A64" FOR INPUT AS #1
		 
	DO WHILE NOT EOF(1)
		LINE INPUT #1, A$

		IF INSTR(UCASE$(A$), ".DAT") > 0 THEN
			C64MusicFile$ = A$
		 
			getsonginfo
		 
			A$ = ""
		 
			IF UCASE$(PsidInfo$) = "PSID" THEN
				PRINT SongName$
				PRINT SongAuthor$
				PRINT SongCopyright$
			END IF
		 
		END IF
	 
	LOOP

END SUB

DEFINT A-Z
SUB SetScreen
	SCREEN 12
END SUB

SUB ShellPorting (PoortRoutine%)
	SubSource$ = "ShellPorting"

	SELECT CASE PoortRoutine%
	 
		CASE IS = 1 'Store sidfile path filenames into a temporary archivedatabase
			SHELL "dir " + C64MusicPath$ + " /s/b/a-d/-o>" + OwnPath$ + "MAINARCH.A64"
		
			
		CASE 2  'Convert gathered Win'95 filename-data to short filename equivalent
			LFNFiles% = FREEFILE
		 
			OPEN OwnPath$ + "MAINARCH.A64" FOR INPUT AS LFNFiles%
		 
			SFNConverted% = FREEFILE
		 
			OPEN OwnPath$ + "MAINARCH.SFN" FOR OUTPUT AS SFNConverted%
		 
			DO WHILE NOT EOF(LFNFiles%)
				LINE INPUT #LFNFiles%, A$
				
				PRINT #SFNConverted%, lfn.l2s$(A$)
			LOOP
		 
			CLOSE
		 
			KILL OwnPath$ + "MAINARCH.A64"
		 
			LFNFiles% = 0
		 
			SFNConverted% = 0
		 
			A$ = ""

		CASE IS = 3
			InputFile$ = OwnPath$ + "MAINARCH.SFN"
		 
			NeededMemSize% = ((FileLines& * Leng%) \ 1024) + 1

			TempHandler% = 1

			FileHandle% = GetXMS(NeededMemSize%)
	
			LoadToXMS InputFile$, NeededMemSize%

		CASE IS = 4
			NeededMemSize% = ((FileLines& * 101) \ 1024) + 1

			DbaseHandle% = GetXMS(NeededMemSize%)

			InputFile$ = OwnPath$ + ExeFile$ + ".IDB"

			TempHandler% = 2

			LoadToXMS InputFile$, NeededMemSize%
	 
		CASE IS = 5
			NeededMemSize% = ((FileLines& * 101) \ 1024) + 1

			DbaseHandle% = GetXMS(NeededMemSize%)

			CheckSidValids

		CASE ELSE
 
	END SELECT

END SUB

DEFSNG A-Z
SUB ShowChars (Text$, MainColor%)
	SubSource$ = UCASE$("ShowChars")

	DroppleX% = (POS(X) - 1) * 8 - 1
	DroppleY% = (CSRLIN - 1) * 16 - 1

	FOR A% = 1 TO LEN(Text$)
			
		'LINE (1 + DroppleX%, 1 + DroppleY%)-(8 + DroppleX%, DroppleY% + 16), BackGroundColor%, BF
	 
		CharValue% = ASC(MID$(Text$, A%, 1))
	 
'    PRINT CharValue%
'    SLEEP
		IF CharValue% <> 32 THEN
	 
			FOR TmpCnt% = 1 TO LEN(CharsPos$(CharValue%)) STEP 2
				'PRINT CharsPos$(CharValue%)
				'SLEEP

				X% = ASC(MID$(CharsPos$(CharValue%), TmpCnt%, 1))
		 
				Y% = ASC(MID$(CharsPos$(CharValue%), TmpCnt% + 1, 1))
		 
				PSET (X% + DroppleX%, Y% + DroppleY%), MainColor%
			NEXT TmpCnt%
		 
		END IF
	 
		DroppleX% = DroppleX% + 8
	
		IF DroppleX% >= 640 THEN
				DroppleX% = 0
			 
				DroppleY% = DroppleY% + 16
		 
				IF DroppleY% > 480 THEN
					DroppleY% = DroppleY% - 16
				END IF
 
		END IF

	NEXT A%
 


	PRINT
 
END SUB

DEFINT A-Z
SUB ShowCommandLineHelp
	PRINT "Only a few commandline parameters you can use here:"
	PRINT
	PRINT ExeFile$ + " [/P0 | /P1]"
	PRINT
	PRINT "/P0:Don't show all those stupid progress meters, just process the shit."
	PRINT "/P1:Only show the progress in percentage-values, no progress-slider."
	PRINT "Nothing:show everything during loads and scans."
	PRINT
 
	END

END SUB

SUB ShowConfiguration
			
	FillViewPort

	MarkArea 1, 2, 11, 78, "Box", 1

	COLOR 11

	LOCATE 3, 2
	PRINT "C64 sid-root:"
	LOCATE CSRLIN, 2
	PRINT C64MusicPath$
	LOCATE CSRLIN, 2
	PRINT STRING$(78, "_")
	LOCATE CSRLIN, 2
	PRINT "Sidplay file location:"
	LOCATE CSRLIN, 2
	PRINT SidPlayPath$
	LOCATE CSRLIN, 2
	PRINT STRING$(78, "_")
	LOCATE CSRLIN, 2
	PRINT "Command parameter string for sidplay:"
	LOCATE CSRLIN, 2
	PRINT SidPlayCommand$
	LOCATE CSRLIN, 2
	PRINT STRING$(78, "_")
	LOCATE CSRLIN, 2
	PRINT "-Key-"

	DO
		T$ = INKEY$
	LOOP WHILE T$ = ""

END SUB

SUB ShowControlHelp
			 
	FillViewPort
 
	MarkArea 1, 2, 14, 78, "Box", 1

	COLOR 11
 
	LOCATE 3, 2
	PRINT "Okay you wanted some help, here you will have some default options:"
	LOCATE CSRLIN, 2
	PRINT STRING$(78, "_")
	LOCATE CSRLIN, 2
	PRINT "[Arrows-Up/Down],[PgUp/PgDn],[Home/End],[Ctrl-Home/-end]: Browse database"
	LOCATE CSRLIN, 2
	PRINT "[Arrows-Left/Right],[TAB]: Show [Author|Title] or [Title|Copyright]"
	LOCATE CSRLIN, 2
	PRINT "[Space]: Select/deselect sidfile"
	LOCATE CSRLIN, 2
	PRINT "[Enter]: Play sidfile (Port to Sidfile-player!)"
	LOCATE CSRLIN, 2
	PRINT "[S] or [ALT-S]: Search for key through sid-data (initialise searchstring)"
	LOCATE CSRLIN, 2
	PRINT "[F3]: Continue search with the same searchkey."
	LOCATE CSRLIN, 2
	PRINT "[G] or [ALT-G]: go to line x: here x must be 1>= and <=" + STR$(FileLines&)
	LOCATE CSRLIN, 2
	PRINT "[Esc]: Simply quit program."
	LOCATE CSRLIN, 2
	PRINT "[F1]: You are looking at the screen right now :)"
	LOCATE CSRLIN, 2
	PRINT "[F2]: Show main user configurations."
	LOCATE CSRLIN, 2
	PRINT STRING$(78, "_")
	LOCATE CSRLIN, 2
	PRINT "-Key-"

	DO
		T$ = INKEY$
	LOOP WHILE T$ = ""

END SUB

SUB ShowInitialInfo (SubInfo%)
 
	SubSource$ = "ShowInitialInfo"
 
	SELECT CASE SubInfo%
	 
		CASE IS = 1
			ZetPointerUit
	
			COLOR TextColorBox%
		 
			LongString$ = "Main data-base builder-info not found!"
		 
			LOCATE CSRLIN + 1, (80 - LEN(LongString$)) \ 2
		
			Startm% = ((CSRLIN - 1) * 16) - 2
		
			PRINT LongString$
		
			LOCATE CSRLIN, (80 - LEN(LongString$)) \ 2
		
			PRINT "         going to build it...         "
		
			LOCATE CSRLIN, (80 - LEN(LongString$)) \ 2
		
			PRINT "       this can take a while...       "
		
			LOCATE CSRLIN, (80 - LEN(LongString$)) \ 2
		
			PRINT "     have some coffee meanwhile...    "
		
			ZetPointerAan
		
			Xmark% = (((80 - LEN(LongString$)) \ 2 - 1) * 8) - 2
		
			BorderLinesButton Xmark%, Startm%, LEN(LongString$), 4
		 
		CASE IS = 2
			ZetPointerUit
 
			COLOR TextColorBox%
	 
			St$ = "Recovering Main database..."
		 
			PLACE 2, CRSLIN + 2, "Box", St$, TextColor%

			PRINT

			ShellPorting 5
		 
			St$ = "Recovering done.Be sure to do an integrity-check!"
		
			PLACE 2, CRSLIN + 4, "Box", St$, TextColor%

			PRINT

			St$ = "The database might have become unreliable!"
	 
			PLACE 2, CRSLIN + 6, "Box", St$, TextColor%

			PRINT

			ZetPointerAan
	 
		CASE IS = 3
			ZetPointerUit

			COLOR TextColorBox%
	
			St$ = "Error encountered adapting Database integrity check..."
		
			PLACE 2, CRSLIN + 2, "Box", St$, TextColor%

			PRINT

			ZetPointerAan
		
		CASE ELSE
	 
	END SELECT

END SUB

DEFSNG A-Z
SUB ShowKey
	SubSource$ = UCASE$("ShowKey")
	 
		DO
			Toets$ = INKEY$

			LOCATE 7, 7
		
			SELECT CASE LEN(Toets$)
			
				CASE IS = 1
					PRINT ASC(Toets$)
			
				CASE IS = 2
					PRINT ASC(LEFT$(Toets$, 1)); ASC(RIGHT$(Toets$, 1))
		
			END SELECT
	 
		LOOP

END SUB

SUB ShowOkButton (CornerX%, CornerY%)
	SubSource$ = "ShowButtonOk"

	Lijntje% = CornerY% + 2

	Horizon% = CornerX% + 2
 
	PointX% = (CornerX% * 8) - 2
 
	PointY% = (CornerY% * 16) - 2
 
	ZetPointerUit
 
	FillRect PointX% + 2, PointY% + 2, PointX% + 178, PointY% + 81
 
	St$ = "Click OK to continue"
 
	PLACE Horizon%, Lijntje%, "Nothing", St$, TextColor%

	LOCATE Lijntje% + 2, CornerX% + 11
 
	St$ = "OK"

	PLACE CornerX% + 11, Lijntje% + 2, "Button", St$, TextColor%

	BorderLinesButton PointX%, PointY%, 22, 5
 
	DO
		LeesMuisIo Button%, Mx%, My%
	
		ZetPointerAan
	
		CheckInkey
		
		IF Button% = 1 OR Toets$ <> "" THEN
		
			IF (Mx% >= PointX% + 80 AND Mx% <= PointX% + 96) AND (My% >= PointY% + 47 AND My% <= PointY% + 62) AND Starter% = 0 OR Toets$ <> "" THEN
				ZetPointerUit
			 
				PLACE CornerX% + 11, Lijntje% + 2, "switchBox", St$, TextColor%
			
				Starter% = 1
			END IF
		
		ELSE
		
			IF Starter% = 1 THEN
				ZetPointerUit
			 
				PLACE CornerX% + 11, Lijntje% + 2, "Button", St$, TextColor%
			
				Starter% = 0

				EXIT DO
			END IF
	
		END IF
	 
	LOOP

	ZetPointerUit

END SUB

DEFINT A-Z
SUB StatusLine (Type$, Line$, XColor%)

	Complete$ = Line$ + STRING$(78 - LEN(Line$), " ")

	PLACE 2, 29, Type$, Complete$, XColor%

END SUB

DEFSNG A-Z
SUB StuurToets (Xl%, Yl%, Type$, EntryString$, Limit%)
	SubSource$ = UCASE$("StuurToets")
 
	XStart% = Xl%
 
	Pixl% = (Xl% * 8) - 10

	Piyl% = (Yl% * 16) - 18

	WordLen! = 1
 
	LimitConv! = Limit%
 
	EntryString$ = ""

	SELECT CASE UCASE$(Type$)

		CASE IS = "BUTTON", "NOTHING"
			COLOR TextColor%
		 
			FillRect Pixl% + 2, Piyl% + 2, Pixl% + (8 * Limit%) + 1, Piyl% + 17
	
		CASE ELSE
			COLOR TextColorBox%
		 
			FillRect Pixl%, Piyl%, Pixl% + (8 * Limit%) + 1, Piyl% + 17

			BorderLinesBox Pixl%, Piyl%, LimitConv!, 1

	END SELECT

	DO
	 
		DO
			CheckInkey
		LOOP UNTIL Toets$ <> "" AND LEN(Toets$) < 2
 
		SELECT CASE Toets$
		 
			CASE CHR$(8)
				IF Xl% > XStart% THEN
					Xl% = Xl% - 1
				 
					EntryString$ = LEFT$(EntryString$, LEN(EntryString$) - 1)
				ELSE
					Toets$ = "Slaover"
				END IF
			 
		END SELECT
	 
		Pixl% = (Xl% * 8) - 10

		Piyl% = (Yl% * 16) - 18
	 
		LOCATE Yl%, Xl%
		 
			IF Toets$ <> CHR$(8) AND Toets$ <> "Slaover" AND Toets$ <> CHR$(13) AND Toets$ <> CHR$(27) THEN
		
				IF LEN(EntryString$) < Limit% THEN
					Xl% = Xl% + 1
				 
					EntryString$ = EntryString$ + Toets$
				 
					IF LEN(EntryString$ + Toets$ + "_") > Limit% + 1 THEN
						WordLen! = 1
					 
						PRINT Toets$
					ELSE
						WordLen! = 2

						PRINT Toets$; "_"
					END IF
			 
				ELSE
					St$ = "Sorry, you can enter up to this limit."
				 
					StatusLine "box", St$, TextColor%
				 
					COLOR TextColor%
				END IF

			ELSE
			 
				IF Toets$ = CHR$(8) THEN
				 
					IF LEN(EntryString$) < Limit% - 1 THEN
						WordLen! = 2
					 
						PRINT "_ "
					ELSE
						WordLen! = 1
					 
						PRINT "_"
					END IF
			 
				ELSE
			 
					IF Toets$ = CHR$(13) OR Toets$ = CHR$(27) THEN
					 
						IF LEN(EntryString$) <> Limit% THEN
							WordLen! = 1
						 
							PRINT " "
						END IF
				 
					END IF

				END IF
		 
		 
			END IF

			FOR YReader% = Piyl% + 2 TO (Piyl% + 18)
			
				FOR XReader% = Pixl% + 2 TO (Pixl% + (WordLen! * 8) + 1)
				
					IF POINT(XReader%, YReader%) = 0 THEN
						PSET (XReader%, YReader%), BackGroundColor%
					END IF
			
				NEXT XReader%
		
			NEXT YReader%
		 
			IF Toets$ = CHR$(13) OR Toets$ = CHR$(27) THEN
			 
				IF Toets$ = CHR$(27) THEN
					EntryString$ = Toets$
				END IF

				EXIT DO
			END IF

	LOOP

END SUB

DEFINT A-Z
SUB Terminate
 
	SCREEN 0
 
	PRINT "Quitting..."

	FreeHandles

	END

END SUB

DEFSNG A-Z
SUB TestMainDatabase
	SubSource$ = UCASE$("testmaindatabase")

	ON ERROR GOTO Fout

	OPEN OwnPath$ + "MAINARCH.SFN" FOR BINARY AS #1
 
	IF LOF(1) = 0 THEN
		CLOSE
	
		FileLines& = 0
	 
		Leng% = 0

		FillViewPort

		KILL OwnPath$ + "MAINARCH.SFN"
	 
		ShowInitialInfo 1

	 '**** shelling dir to Mainarch.a64
		ShellPorting 1
	
	 '**** Check if win'95 if so, convert LFN to SFN else rename MAINARCH.A64
		IF OsMode% >= 4 THEN
			ShellPorting 2
		ELSE
			NAME OwnPath$ + "MAINARCH.A64" AS OwnPath$ + "MAINARCH.SFN"
		END IF

	 '**** CountFilelines
		InputFile$ = OwnPath$ + "MAINARCH.SFN"
	
		CountPSIDFiles InputFile$
		
	 '**** Calculate memory for this filesession and upload to memory
		ShellPorting 3

	 '***** Sort it
		HuthSort
	 
		FillViewPort
	 
		LOCATE 2, 1
	
	 '**** Strip Non-sid files from memory
		NeededMemSize% = ((FileLines& * 102) \ 1024) + 2

		DbaseHandle% = GetXMS(NeededMemSize%)

		CheckSidValids
 
		FreeHandles
	ELSE
		InputFile$ = OwnPath$ + "MAINARCH.SFN"
 
		CountPSIDFiles InputFile$

	END IF
 
	CLOSE
 
	FillViewPort
	
	LOCATE 2, 1
 
	NeededMemSize% = ((FileLines& * Leng%) \ 1024) + 1
 
	FileHandle% = GetXMS(NeededMemSize%)

	InputFile$ = OwnPath$ + "MAINARCH.SFN"

	TempHandler% = 1

	LoadToXMS InputFile$, NeededMemSize%

	OPEN OwnPath$ + ExeFile$ + ".IDB" FOR BINARY AS #1

	IF LOF(1) = 0 THEN
		CLOSE
 
		FillViewPort

		KILL OwnPath$ + ExeFile$ + ".IDB"
	
		NeededMemSize% = ((FileLines& * 102) \ 1024) + 2

		DbaseHandle% = GetXMS(NeededMemSize%)

		ArrangeSidData
	 
		CALL FreeXMS(DbaseHandle%)
	ELSE
	 
		IF LOF(1) \ 100 <> FileLines& THEN
			CLOSE

			FillViewPort

			KILL OwnPath$ + ExeFile$ + ".IDB"
 
			NeededMemSize% = ((FileLines& * 102) \ 1024) + 2

			DbaseHandle% = GetXMS(NeededMemSize%)

			ArrangeSidData
	
			CALL FreeXMS(DbaseHandle%)
		 
			CALL FreeXMS(FileHandle%)

			NeededMemSize% = ((FileLines& * Leng%) \ 1024) + 1

			FileHandle% = GetXMS(NeededMemSize%)

			InputFile$ = OwnPath$ + "MAINARCH.SFN"

			TempHandler% = 1

			LoadToXMS InputFile$, NeededMemSize%
		END IF
 
	END IF
 
	CLOSE

	NeededMemSize% = ((FileLines& * 102) \ 1024) + 2
 
	DbaseHandle% = GetXMS(NeededMemSize%)
 
	InputFile$ = OwnPath$ + ExeFile$ + ".IDB"

	TempHandler% = 2

	LoadToXMS InputFile$, NeededMemSize%
	
	ShowOkButton 28, 12
 
	FillViewPort
 
	QuitButton% = 0

END SUB

SUB TestMouse
	SubSource$ = UCASE$("TestMouse")
 
	Muis 0, Button%, Mx%, My%
 
	IF Button% > 0 THEN
		St$ = "Mouse found..."
	 
		PLACE 2, CSRLIN + 1, "BOX", St$, TextColor%
	 
		PRINT
	ELSE
		St$ = "Mouse not found, use ALT-capital keys on buttons instead"
	
		PLACE 2, CSRLIN + 1, "BOX", St$, TextColor%
	 
		PRINT
	END IF
 
END SUB

