'
' Routine Declarations of Sidbase modules
'
'
'
'
'

'*ISWIN.BAS

  TYPE FarPtr
    Offset AS INTEGER             'offset
   
    Segment AS INTEGER            'segment
  END TYPE

'*XMS Handler
 
  TYPE StackType
    low AS LONG
         
    hi AS LONG
  END TYPE

  TYPE FileBuffer
    FileLine AS STRING * 128
  END TYPE
                       
  TYPE DbaseBuffer
    DbaseLine AS STRING * 102
  END TYPE

'*XMS Handler

  DECLARE FUNCTION GetXMS% (Handle%)
  DECLARE FUNCTION GetReeks$ (Nummer&)
  DECLARE FUNCTION WhichXError% ()
  DECLARE FUNCTION XMSError% ()

'*SidBase.BAS
 
  DECLARE FUNCTION FullPath$ ()

'*ISWIN.BAS
 
  DECLARE FUNCTION DetectSwitcher ()
  DECLARE FUNCTION WinGetVM ()
  DECLARE FUNCTION IsWin (Major AS INTEGER, Minor AS INTEGER, Mode AS INTEGER)

'*LFN.BAS

  DECLARE FUNCTION lfn.cwd$ (drive%)         'get current working directory
  DECLARE FUNCTION lfn.l2s$ (longname$)      'long name to short name
  DECLARE FUNCTION lfn.s2l$ (shortname$)     'short name to long name
  DECLARE FUNCTION lfn.findfirst$ (filespec$, findattrib%, mustattrib%)
  DECLARE FUNCTION lfn.findnext$ ()

'*SidBase.BAS
 
  DECLARE SUB ArrangeSidData ()
  DECLARE SUB AttentOSMode ()
  DECLARE SUB BorderLinesBox (StartX%, StartY%, Letters!, Rules%)
  DECLARE SUB BorderLinesButton (StartX%, StartY%, Letters!, Rules%)
  DECLARE SUB BuildControlScreen ()
  DECLARE SUB Cancel ()
  DECLARE SUB CheckIniFile ()
  DECLARE SUB CheckInkey ()
  DECLARE SUB CheckSidValids ()
  DECLARE SUB ClearIni ()
  DECLARE SUB ControlCentre ()
  DECLARE SUB Coordinator (Module$, SubSource$)
  DECLARE SUB CountPSIDFiles (InputFile$)
  DECLARE SUB CreateBorders ()
  DECLARE SUB FillCenter ()
  DECLARE SUB FillRect (Xa%, Ya%, Xb%, Yb%)
  DECLARE SUB FillViewPort ()
  DECLARE SUB GetRootFileInfo ()
  DECLARE SUB getsonginfo ()
  DECLARE SUB InsertSearchKey (Search$)
  DECLARE SUB LeesMuisIo (Button%, Mx%, My%)
  DECLARE SUB MarkArea (X%, Y%, TextLines%, TLineLen%, Type$, Empty%)
  DECLARE SUB MoveSwapPathToOwn ()
  DECLARE SUB Muis (DataIO%, Button%, Mx%, My%)
  DECLARE SUB PLACE (Xl%, Yl%, Type$, St$, MainColor%)
  DECLARE SUB PrepareSwapPath ()
  DECLARE SUB Progress (Percent%, Kleur%)
  DECLARE SUB Quit ()
  DECLARE SUB RetrieveSongDatas ()
  DECLARE SUB ReadChars ()
  DECLARE SUB SetScreen ()
  DECLARE SUB ShellPorting (PoortRoutine%)
  DECLARE SUB ShowChars (Text$, MainColor%)
  DECLARE SUB ShowCommandLineHelp ()
  DECLARE SUB ShowConfiguration ()
  DECLARE SUB ShowControlHelp ()
  DECLARE SUB ShowInitialInfo (SubInfo%)
  DECLARE SUB ShowOkButton (CornerX%, CornerY%)
  DECLARE SUB StatusLine (Type$, Line$, XColor%)
  DECLARE SUB StuurToets (Xl%, Yl%, Type$, EntryString$, Limit%)
  DECLARE SUB Terminate ()
  DECLARE SUB TestMainDatabase ()
  DECLARE SUB TestMouse ()
  DECLARE SUB ZetPointerAan ()
  DECLARE SUB ZetPointerUit ()

'*ISWIN.BAS
 
  DECLARE SUB SeekWindows ()
  DECLARE SUB DOSGetVector (Number AS INTEGER, Vector AS FarPtr)

'*LFN.BAS
 
  DECLARE SUB lfn.mkdir (dirname$)           'make LFN directory
  DECLARE SUB lfn.rmdir (dirname$)           'remove LFN directory
  DECLARE SUB lfn.chdir (dirname$)           'change to a LFN directory
  DECLARE SUB lfn.del (filename$)            'delete a LFN file
  DECLARE SUB lfn.ren (oldname$, newname$)   'rename file
  DECLARE SUB lfn.findclose ()

'*XMSHandler
 
  DECLARE SUB CheckXMs ()
  DECLARE SUB FreeHandles () 'Clearing all possible XMS-handles
  DECLARE SUB HuthSort () ' Mike Huth's SortAlgorithm
  DECLARE SUB LoadToXMS (InputFile$, NeededMemSize%)
  DECLARE SUB PutReeks (Variabele$, Nummer&) 'Interface between XMS and Basic memory.
  DECLARE SUB ShowXmsError (XmsXError%)
  DECLARE SUB Switch (A&, B&) 'Interface between XMS and Basic memory.

'#end declaration

