' Mousecontroller-file
'
' This routine does some standard mouse coordination stuphz.
'
' The coordinator will allow you to register coordinates of a box-area wich
' will be implemented in a small routine ported to a txt-file wich you can
' later on load as a Document file to copy to the programmed routine.
'
' For instance you have a Button placed somewhere on your screen, you can
' mark it's area by clicking on the startingpoint of the upper left corner
' sliding down to the lower right corner (holding down the button) and then
' release your mousebutton.
'
' It will asc for a description so you can give that area a name like
' "Ok-button"
'
' All info will be ported to a file called "MUISCRD.TXT"
'
' It's a very simple routine nothing really special but offers some comfort.
'
' This is a tool only, you may use this tool or implement routines inside
' your own on condition you credit me for the effort of it!
'
' Vincent Voois 1996-1997
'
'

	DECLARE SUB BepaalMuisLimits ()
	DECLARE SUB Coordinator (Module$, SubSource$)
	DECLARE SUB LeesMuisIo (Button%, Mx%, My%)
	DECLARE SUB Muis (DataIO%, Button%, Mx%, My%)
	DECLARE SUB ZetPointerAan ()
	DECLARE SUB ZetPointerUit ()
 
	REM $INCLUDE: 'qb.bi'

						' This tool works in vga-mode with a mouse-POINTER
	SCREEN 12 ' For standard 25*80 screen adapt a 480/16 and 640/8 formula to
						' calculate column and line position of the mouse-CURSOR

	BepaalMuisLimits

	ZetPointerAan

	Coordinator "MUISCTRL.BAS", "MAIN"
 
	ZetPointerUit

	SCREEN 0

SUB BepaalMuisLimits
	' Determine mouse area limits

	DataIO% = 7

	Muis DataIO%, Button%, 0, 640 ' Screenwidth

	DataIO% = 8

	Muis DataIO%, Button%, 0, 480 ' ScreenHeight

END SUB

SUB Coordinator (Module$, SubSource$)
	CoorFile% = FREEFILE
 
	OPEN "MUISCRD.TXT" FOR APPEND AS #CoorFile%
 
	DO

		LeesMuisIo Button%, Mx%, My%
	 
		Muis 11, Buttonx%, Mxa%, Mya%
	 
		IF Mxa% = 0 AND Mya% = 0 THEN
			ZetPointerAan
		END IF
	 
		IF Button% = 1 THEN
		 
			IF Starter% = 0 THEN
				Xa% = Mx%
			 
				Ya% = My%
			END IF
		
			Starter% = 1

			LINE (Xa%, Ya%)-(Xa% + (Mx% - Xa%), Ya%), 15
			LINE (Xa%, Ya%)-(Xa%, Ya% + (My% - Ya%)), 15
			LINE (Xa% + (Mx% - Xa%), Ya% + (My% - Ya%))-(Xa% + (Mx% - Xa%), Ya%), 15
			LINE (Xa% + (Mx% - Xa%), Ya% + (My% - Ya%))-(Xa%, Ya% + (My% - Ya%)), 15
		 
			Muis 11, Buttonx%, Mxa%, Mya%
		
			IF Mxa% <> 0 OR Mya% <> 0 THEN
				ZetPointerUit
			END IF
		 
			IF Xa% < Mx% THEN
				LINE (Xa% + 1, Ya% + 1)-(Mx% - 1, My% - 1), 0, BF
			ELSE
				LINE (Mx% + 1, My% + 1)-(Xa% - 1, Ya% - 1), 0, BF
			END IF
		 
			IF Mxa% = 0 AND Mya% = 0 THEN
				ZetPointerAan
			END IF
	 
		ELSE
		
			IF Starter% = 1 THEN
				Starter% = 0
			 
				ZetPointerUit
			 
				LINE (Xa%, Ya%)-(Xa% + (Mx% - Xa%), Ya%), 15
				LINE (Xa%, Ya%)-(Xa%, Ya% + (My% - Ya%)), 15
				LINE (Xa% + (Mx% - Xa%), Ya% + (My% - Ya%))-(Xa% + (Mx% - Xa%), Ya%), 15
				LINE (Xa% + (Mx% - Xa%), Ya% + (My% - Ya%))-(Xa%, Ya% + (My% - Ya%)), 15
			 
				IF Xa% < Mx% THEN
					LINE (Xa% + 1, Ya% + 1)-(Mx% - 1, My% - 1), 0, BF
				ELSE
					LINE (Mx% + 1, My% + 1)-(Xa% - 1, Ya% - 1), 0, BF
				END IF
			 
				ZetPointerAan

				Xb% = Mx%
			 
				Yb% = My%
		 
				EXIT DO
			END IF

		END IF

	LOOP

	PRINT "Geef omschrijving coordinaten:"
 
	LINE INPUT Coordinats$
 
	PRINT #CoorFile%, "Module:" + Module$ ' Name of the main module
	PRINT #CoorFile%, "Sub:" + SubSource$ ' Name of the subroutine you implement
																				' the mouseroutine on this area
	PRINT #CoorFile%, "Omschrijving:" + Coordinats$ ' description of selected area
	PRINT #CoorFile%, "  DO"
	PRINT #CoorFile%, "    LeesMuisIo Button%, Mx%, My%"
	PRINT #CoorFile%, "    "
	PRINT #CoorFile%, "    ZetPointerAan"
	PRINT #CoorFile%, "    "
	PRINT #CoorFile%, "    IF Button% = 1 THEN"
	PRINT #CoorFile%, "    "
	PRINT #CoorFile%, "      IF (Mx% >= " + STR$(Xa%) + " AND Mx% <= " + STR$(Xb%) + ") AND (My% >= " + STR$(Ya%) + " AND My% <= " + STR$(Yb%) + ") AND Starter% = 0 THEN"
	PRINT #CoorFile%, "        ZetPointerUit"
	PRINT #CoorFile%, "    "   ' Insert something like : PRINT "Okay Clicked!"
	PRINT #CoorFile%, "        Starter% = 1"
	PRINT #CoorFile%, "      END IF"
	PRINT #CoorFile%, "    "
	PRINT #CoorFile%, "    ELSE"
	PRINT #CoorFile%, "    "
	PRINT #CoorFile%, "      IF Starter% = 1 then"
	PRINT #CoorFile%, "        Starter% = 0"
	PRINT #CoorFile%, "    " ' Insert something like : PRINT "Button released!"
	PRINT #CoorFile%, "        EXIT DO"
	PRINT #CoorFile%, "      END IF"
	PRINT #CoorFile%, "    "
	PRINT #CoorFile%, "    END IF"
	PRINT #CoorFile%, "  "
	PRINT #CoorFile%, "  LOOP"
	PRINT #CoorFile%, "  "
	PRINT #CoorFile%, "  ZetPointerUit"
 
	CLOSE #CoorFile%

END SUB

SUB LeesMuisIo (Button%, Mx%, My%)
	 'Read mouse IO only!

	DataIO% = 3
	
	Muis DataIO%, Button%, Mx%, My%

END SUB

SUB Muis (DataIO%, Button%, Mx%, My%)

	' Read mouseIO status like, position of pointer, button pressed etc.
 
	DIM MuisIO AS RegType
 
	MuisIO.ax = DataIO%
 
	MuisIO.bx = Button%
 
	MuisIO.cx = Mx%
 
	MuisIO.dx = My%

	CALL INTERRUPT(51, MuisIO, MuisIO)
	
	DataIO% = MuisIO.ax
 
	Button% = MuisIO.bx
 
	Mx% = MuisIO.cx
 
	My% = MuisIO.dx

 END SUB

SUB ZetPointerAan
	' Turn on Pointer
 
	Muis 1, 0, 0, 0
END SUB

SUB ZetPointerUit
	' Turn Off Pointer

	Muis 2, 0, 0, 0
END SUB

